﻿
#PBDATA_Error_Unknown     =  0
#PBDATA_Error_Encryption  = -1
#PBDATA_Error_CRC32       = -2

Procedure.l __PBData_RC4Mem__(Mem.l, memLen.l, key.s)

  Protected I.l, J.l, *S.Byte, *KeyP.Byte, *Memm.Character

  Dim S.l(255)
  Dim K.l(255)

  *S.Byte = @S()
  *KeyP.Byte  = @key

  For I = 0 To 255
    *S\b = I
    *S + 4
    If *KeyP\b = 0 : *KeyP = @key : EndIf
    K(I) = *KeyP\b
    *KeyP + 1
  Next I

  For I = 0 To 255
    j = (j + S(I) + K(I)) & 255
    Swap S(I), S(j)
  Next I

  I = 0
  j = 0

  For *Memm.Character = Mem To Mem + memLen - 1
    I = (I+1) & 255
    j = (j + S(I)) & 255
    Swap S(I), S(j)
    *Memm\c ! S((S(I) + (S(j) & 255)) & 255)
  Next

  ProcedureReturn Mem
EndProcedure


Procedure GetPBData(Nr.l, Key.s = "", hModule.l = 0)

  Protected Key_Unicode.s, ResName.s, ResType.s = "PBDATA"
  Protected hFind.l, hLoad.l, hLock.l, hSize.l, MemD.l, MemS.l, Size.q

  If Key

    CompilerIf #PB_Unicode

      Key_Unicode = Key
      PokeS(@Key, Key_Unicode, #PB_Any, #PB_Ascii)

    CompilerEndIf

  EndIf

  ResName = "#" + Str(Nr)

  If Not hModule : hModule = GetModuleHandle_(#Null) : EndIf

  hFind = FindResource_(hModule, ResName, @ResType)

  If hFind

    hLoad = LoadResource_(hModule, hFind)
    hSize = SizeofResource_(hModule, hFind)
    hLock = LockResource_(hLoad)

    MemS = AllocateMemory(hSize)

    If MemS

      CopyMemory(hLock, MemS, hSize)
      FreeResource_(hLock)

      If Key

        __PBData_RC4Mem__(MemS, hSize, Key)

        If Not MD5Fingerprint(@Key, Len(Key) * SizeOf(Character)) = PeekS(MemS + 8, 32, #PB_Ascii)

          FreeMemory(MemS)
          ProcedureReturn #PBDATA_Error_Encryption

        EndIf

      Else

        If PeekS(MemS + 8, 32)

          FreeMemory(MemS)
          ProcedureReturn #PBDATA_Error_Encryption

        EndIf

      EndIf

      Size = PeekL(MemS)

      If Size > 0

        MemD = AllocateMemory(Size)

        If MemD

          If UnpackMemory(MemS + 41, MemD)

            If PeekL(MemS + 4) <> CRC32Fingerprint(MemD, MemorySize(MemD))

              FreeMemory(MemS)
              FreeMemory(MemD)
              ProcedureReturn #PBDATA_Error_CRC32

            EndIf

            FreeMemory(MemS)
            ProcedureReturn MemD

          EndIf

        EndIf

      Else

        Size - 2 * Size

        If Size > 0

          MemD = AllocateMemory(Size)

          If MemD

            CopyMemory(MemS + 41, MemD, Size)

            If PeekL(MemS + 4) <> CRC32Fingerprint(MemD, MemorySize(MemD))

              FreeMemory(MemS)
              FreeMemory(MemD)
              ProcedureReturn #PBDATA_Error_CRC32

            EndIf

            FreeMemory(MemS)
            ProcedureReturn MemD

  EndIf : EndIf : EndIf : EndIf : EndIf
EndProcedure

Procedure SavePBData(FileName.s, Nr.l, Key.s = "", hModule.l = 0)

  Protected FileID.l, Mem.l

  FileID = CreateFile(#PB_Any, FileName)

  If FileID

    Mem = GetPBData(Nr, Key, hModule)

    If Mem > 0

      WriteData(FileID, Mem, MemorySize(Mem))
      CloseFile(FileID)
      FreeMemory(Mem)
      ProcedureReturn #True

    EndIf

    CloseFile(FileID)
    DeleteFile(FileName)

  EndIf
EndProcedure
